# Html to pdf
Web service using [Grover pdf](https://github.com/Studiosity/grover) to generate and manipulate pdfs, png and jpg

## Routes
### /v1/render
Given `url` or `html`, will generate a `pdf`, `png` or `jpg` using [Grover gem](https://github.com/Studiosity/grover).
Accepted params:
| name | type |
| --- | --- |
| `url / html` | Same usage. Will be given to Grover as first param. |
| output_format | `pdf / png / jpg` : what type of output do you want? |
| grover_options | Will be given to Grover as options for generation. You can provide these options in the body as well. |
| filename | Name of the downloaded file without extension |

TODO example with params in the body without grover_options.

## Troubleshooting
- `url` always wants protocol. so specify either `http` or `https`. if you provide url=google.com , you'll get a file with the text `google.com`.

## Examples
```txt
http://localhost:8080/v1/render?url=https://laportadacqua.com&output_format=png&grover_format=a5

http://localhost:8080/v1/render?html=%3Ch1%3ECiao!%3C/h1%3E&output_format=png&grover_format=a5
```

## Local setup with Docker
Having access to the repository of this project you can build it locally.
```bash
docker build . -t myapp && docker run -p 8080:8080 myapp
```