module V1
  class RenderController < ApplicationController
    def call(req)
      params = req.params.with_indifferent_access

      puts <<~HEREDOC
        V1::RenderController#call
        params: #{params.inspect}
      HEREDOC

      call = RenderGrover.run(params: params)

      if call.valid?
        return render custom: {
          body: call.result,
        }, headers: call.headers
      end

      render json: {
        error: call.errors.full_messages.join(', ')
      }
    end
  end
end
