# # frozen_string_literal: true

# class UpdateExistingPdf < ActiveInteraction::Base
#   interface :params, methods: %i[[] merge! fetch each has_key?], default: {}

#   validate do
#     unless original_pdf.present?
#       errors.add(:base, "param :pdf is required. It has to be a PDF file or a link to a PDF file. #{params[:pdf].inspect}")
#     end

#     unless partials.is_a?(Array)
#       errors.add(:base, "param :partials is required. It has to be an array of Hash. #{params[:partials].inspect}")
#     end

#     common_grover_options # May add errors

#     # validate_partials
#   end

#   def execute

#     # return render json: { message: "pdf is invalid or blank (#{params[:pdf].inspect})" }, status: 400 if pdf.nil?

#     doc = HexaPDF::Document.open(original_pdf)

#     partials.each do |item|
#       return errors.add(:base, "page is invalid (#{item[:page].inspect})") if !item[:page].to_s.match?(/^\d+$/) || !item[:page].to_i.positive?
#       page = doc.pages[item[:page].to_i - 1]
#       return errors.add(:base, "invalid page #{item[:page].to_i}: out of range") if page.nil?
#       canvas = page.canvas(type: :overlay)

#       image = image_for(item)
#       # return if image.nil? || errors.any?

#       # at = at_for(item)
#       # return errors.add(:base, "param :at should be a array with [x, y] coordinates. got #{at.inspect}") unless at.is_a?(Array) && at.length == 2

#       hexa_options = hexa_options_for(item)
#       return if errors.any? || invalid? || image.nil?

#       canvas.image(image.path, **hexa_options)
#     end

#     @file = Tempfile.new(["updated", ".pdf"])
#     doc.write(@file.path)
#     @file.rewind

#     @file
#   end

#   def close
#     @file.close
#     @file.unlink
#   end

#   def filename_with_extension
#     "updated.pdf"
#   end

#   private

#   def hexa_options_for(item)
#     options = { at: item[:at].map(&:to_f) }
#     options[:width] = item[:width].to_i if item[:width].to_i.positive?
#     options[:height] = item[:height].to_i if item[:height].to_i.positive?

#     options
#   end

#   def original_pdf
#     return @original_pdf if defined?(@original_pdf)

#     @original_pdf = nil
#     @original_pdf = params[:pdf] if params[:pdf].is_a?(ActionDispatch::Http::UploadedFile)
#     if @original_pdf.nil? && params[:pdf].is_a?(String) && params[:pdf].start_with?("http")
#       @original_pdf = download(url: params[:pdf], filename: ["pdf", ".pdf"])
#     end

#     @original_pdf
#   end

#   def partials
#     return @partials if defined?(@partials)

#     @partials = params[:partials]
#     @partials = JSON.parse(@partials).map(&:with_indifferent_access) if @partials.is_a?(String) && @partials.valid_json?

#     # @partials = @partials.map(&:permit!).map(&:to_h) if @partials.all? { |p| p.is_a?(ActionController::Parameters) }

#     @partials = @partials.filter(&:present?) if @partials.is_a?(Array)
#     #

#     @partials
#   end

#   def common_grover_options
#     return @common_grover_options if defined?(@common_grover_options)
#     if params[:grover_options].present?
#       @common_grover_options = JSON.parse(params[:grover_options]) if params[:grover_options].is_a?(String) && params[:grover_options].valid_json?
#       @common_grover_options = params[:grover_options].permit!.to_h if params[:grover_options].is_a?(ActionController::Parameters)

#       errors.add(:base, "invalid params[:grover_options] #{@common_grover_options.inspect}") if @common_grover_options.nil?
#     end

#     @common_grover_options = DEFAULT_GROVER_OPTIONS.merge(@common_grover_options || {})
#   end

#   def format_grover_options_for(item)
#     grover_options = nil
#     if item[:grover_options].present?
#       grover_options = JSON.parse(item[:grover_options]) if item[:grover_options].is_a?(String) && item[:grover_options].valid_json?
#       grover_options = item[:grover_options].permit!.to_h if item[:grover_options].is_a?(ActionController::Parameters)
#       grover_options = item[:grover_options] if item[:grover_options].is_a?(Hash)

#       errors.add(:base, "invalid item[:grover_options]") if grover_options.nil?
#     end

#     common_grover_options.merge(grover_options || {})
#   end

#   def image_for(item)
#     image = nil

#     if item[:image].present?
#       image = params[item[:image].to_sym] if item[:image].is_a?(String) && params[item[:image]].is_a?(ActionDispatch::Http::UploadedFile)
#       if image.nil? && item[:image].is_a?(String) && item[:image].start_with?("http")
#         image = download(url: item[:image], filename: ["image", ".png"])

#         return if image.nil? # Error will be added by #download method. Just exit.
#       end

#       return errors.add(:base, "item[:image] is invalid or blank (#{item[:image].inspect})") if image.nil?
#     end

#     if image.nil? && (item[:html].present? || item[:url].present?)
#       grover = Grover.new(item[:html] || item[:url], **(format_grover_options_for(item).to_h.transform_keys(&:to_sym)))

#       case item[:as].to_s.strip
#       when "png"
#         image = Tempfile.new(["image", ".png"], binmode: true)
#         File.open(image.path, "wb") { |f| f.write(grover.to_png) }
#       when "jpeg"
#         image = Tempfile.new(["image", ".jpeg"], binmode: true)
#         File.open(image.path, "wb") { |f| f.write(grover.to_jpeg) }
#       else
#         if item[:as].blank?
#           image = Tempfile.new(["image", ".png"], binmode: true)
#           File.open(image.path, "wb") { |f| f.write(grover.to_png) }
#         else
#           if item[:as].present? && !%w[png jpeg].include?(item[:as].to_s)
#             return errors.add(:base, "Invalid :as value. Use :png or :jpeg. got #{item[:as].inspect}")
#           end
#         end
#       end

#       image.rewind
#     end

#     errors.add(:base, "Image is nil") if image.blank?

#     image
#   end

#   def download(url:, filename:)
#     uri = URI.parse(url)
#     http = Net::HTTP.new(uri.host, uri.port)
#     http.use_ssl = true
#     request = Net::HTTP::Get.new(uri.request_uri)
#     response = http.request(request)
#     file = Tempfile.new(filename, binmode: true)
#     File.open(file.path, "wb") { |f| f.write(response.body) }
#     file
#   rescue StandardError => e
#     errors.add(:base, e.to_s)
#     nil
#   end
# end