# frozen_string_literal: true

module Middlewares
  class ParseRequest
    def initialize(app)
      @app = app
    end

    def call(env)
      req = Rack::Request.new(env)

      if (json_body = req.body.read.valid_json?)
        req.params.merge!(json_body) if json_body
      end

      req.body.rewind

      @app.call(req)
    end
  end
end
