# require 'rackup'

ENV["BUNDLE_GEMFILE"] ||= File.expand_path("Gemfile", __dir__)

if ENV['RACK_ENV'] == 'development'
  require "debug" 
  require "rack/reloader"
end

require "bundler"
Bundler.require
# require "rack/runtime"
# require "rack/request"
# require "rack/response"

ROOT = File.dirname(__FILE__).freeze

Agoo::Server.init(8080, File.dirname(__FILE__))

Agoo::Log.configure(
  dir: 'log',
  console: true,
  classic: true,
  colorize: true,
  states: {
    INFO: true,
    DEBUG: false,
    connect: true,
    request: true,
    response: true,
    eval: true,
    push: false,
  }
)

Agoo::Server.use(Rack::Reloader, 0) if ENV['RACK_ENV'] == 'development'
# Dir[File.join(File.dirname(__FILE__), 'initializers', '**', '*.rb')].each { |file| require file }
Dir[File.join(File.dirname(__FILE__), 'app', '**', '*.rb')].each { |file| require file }


Agoo::Server.use(Middlewares::ParseRequest)
Agoo::Server.use(Middlewares::DefaultResponse)

Agoo::Server.handle(:GET, "/v1/render", V1::RenderController.new)
Agoo::Server.handle(:POST, "/v1/render", V1::RenderController.new)

Agoo::Server.handle(:GET, "/", V1::WelcomeController.new)

Agoo::Server.start
